<?php

/**
 * Plugin Name: ParOne Feeds
 * Plugin URI: https://docs.parone.com
 * Description: Tools for distributing ParOne video feeds in WordPress.
 * Version: 1.15.10
 * Author: ParOne, Inc.
 * License: GPLv3
 * License URI: https://www.gnu.org/licenses/gpl-3.0.html
 *
 * @package parone
 */

defined('ABSPATH') || exit;

/*
  This function pulls the tab stuff from the stuff and stuffs it
*/
function parone_video_page_html() {
  $redirect = "";
  if (isset($_SERVER['REQUEST_URI'] )) {
// phpcs:disable
    $url = sanitize_url($_SERVER['REQUEST_URI']);
// phpcs:enable
    $redirect = urlencode( $url );
  }
  ?>
  <form method="POST" action="<?php echo esc_url(admin_url( 'admin-post.php' )); ?>">
  <input type="hidden" name="action" value="parone_video_feed_handler">
  <input type="hidden" name="_wp_http_referer" value="<?php echo esc_attr($redirect); ?>">
  <p style="text-align: right;">
  <?php
    if (current_user_can('install_plugins')) {
      $submit_sync = get_submit_button('Get Feeds', 'primary large', 'submit', false);

      echo 'Feed Key: <input type="text" id="parone_sync_code" name="parone_sync_code" value="' . esc_attr(get_option( 'parone_sync_code')) . '"/>';
      echo $submit_sync . "&nbsp";
    }
  ?>
  </form>
  <div>
  <?php
    $feed_names = get_option("parone_video_feeds", array('default'));

    $language_code = get_option('parone-default_parone_lang', 'English');
    $default_lang = parone_get_language_code($language_code);

    $feed_list = json_encode($feed_names);
    parone_logdebug("Feeds: $feed_list\n");
    echo "<parone-network-videos cms='Wordpress' feeds=$feed_list defaultlang=\"${default_lang}\"> </parone-network-videos>";
  ?>
  </div>
  <?php
}

add_action( 'admin_post_parone_video_feed_handler', 'parone_video_feed_handler' );


// this also needs to clean
function parone_video_feed_handler() {
  parone_logdebug("In video handler!");
  
  // do we delete or what?
  
// phpcs:disable
  if (!isset($_POST['submit'])) return;
  
  $action = $_POST['submit'];
// phpcs:enable
  
  if ($action == "Get Feeds") {
    parone_set_video_library_feeds();
  }

  // redirect
  $url = "";
// phpcs:disable
  if (isset( $_POST['_wp_http_referer'])) {
    $url = urldecode( $_POST['_wp_http_referer']);
  }
  parone_logdebug("URL: " . $url);
  // we need to remove or change the tab value in the URL
  $parone_active_tab = isset( $_GET[ 'tab' ] ) ? $_GET[ 'tab' ] : 'default';
  $url = remove_query_arg( 'tab', $url );
  parone_logdebug("NewURL: " . $url);
  $url = add_query_arg( 'tab', $feed_name, $url );
// phpcs:enable

  wp_safe_redirect( $url );
  exit();
}

function parone_set_video_library_feeds() {
    $feed_key = $_POST['parone_sync_code'];
    update_option("parone_sync_code", $feed_key);
    
    // let's pull the feed then create if necessary
    // only production sites!
    $url = "https://api.parone.io/find_feeds/" . $feed_key; 
    $response = wp_remote_get($url);
    
    $feedList = json_decode($response['body']);
    update_option("parone_video_feeds", $feedList);
 }



